﻿Procedure SetForegroundWindowInternal(hWnd)
    If Not IsWindow_(hWnd) : ProcedureReturn : EndIf
     
    ; relation time of SetForegroundWindow lock
    Protected lockTimeOut.l = 0;
    Protected hCurrWnd = GetForegroundWindow_();
    Protected dwThisTID.l = GetCurrentThreadId_()
    Protected dwCurrTID.l = GetWindowThreadProcessId_(hCurrWnd,0);
    
    ; we need To bypass some limitations from Microsoft :)
    If (dwThisTID <> dwCurrTID)
        AttachThreadInput_(dwThisTID, dwCurrTID, #True);
         
        SystemParametersInfo_(#SPI_GETFOREGROUNDLOCKTIMEOUT,0,@lockTimeOut,0);
        SystemParametersInfo_(#SPI_SETFOREGROUNDLOCKTIMEOUT,0,0,#SPIF_SENDWININICHANGE | #SPIF_UPDATEINIFILE);
         
        #ASFW_ANY = -1
        AllowSetForegroundWindow_(#ASFW_ANY);
    EndIf
     
    SetForegroundWindow_(hWnd);
    ;SetFocus_(hWnd)
     
    If (dwThisTID <> dwCurrTID)
        SystemParametersInfo_(#SPI_SETFOREGROUNDLOCKTIMEOUT,0,lockTimeOut,#SPIF_SENDWININICHANGE | #SPIF_UPDATEINIFILE);
        AttachThreadInput_(dwThisTID, dwCurrTID, #False);
    EndIf
EndProcedure

Procedure RunMSXhelp(url.s)
    ;ProcedureReturn RunProgram(url)
    ProcedureReturn ShellExecute_(0,@"open",@url,0,0,0)
EndProcedure

Procedure OpenHelp3(topic.s)
    ProcedureReturn RunMSXhelp("ms-xhelp:///?method=f1&query="+topic+"&format=html&devlang=c++&targetos=windows&product=vs&productversion=100&embedded=true");&embedded=true&locale=en-us")
EndProcedure

Procedure SearchHelp3(topic.s)
    ProcedureReturn RunMSXhelp("ms-xhelp:///?method=search&query="+topic+"&format=html&devlang=c++&targetos=windows&ProductVersion=100&Product=vs&PageSize=10&PageNumber=1&embedded=true");&embedded=true&locale=en-us")
EndProcedure

Procedure SearchHelp3Keyword(keyword.s)
    RunMSXhelp("ms-xhelp:///?method=keywords&format=html&query="+keyword+"&product=vs&productversion=100&locale=en-us&category=topic")
EndProcedure

Procedure SearchHelp3Online(topic.s)
    ProcedureReturn RunMSXhelp("http://msdn.microsoft.com/query/dev10.query?appId=Dev10IDEF1&l=EN-US&k=k("+topic+")&rd=true")
EndProcedure



;OpenHelp3("winuser/SendMessage")
;OpenHelp3("winuser/CreateWindowEx")
;OpenHelp3("winuser/DrawText")

;OpenHelp3("shellapi/DragQueryFile")

;OpenHelp3("wincon/AttachConsole")

;OpenHelp3("SendMessage")
;OpenHelp3("CreateWindowEx")
;OpenHelp3("DragQueryFile")
;OpenHelp3("AttachConsole")
;OpenHelp3("DrawText")      ; DOESNT WORK
;OpenHelp3("WM_QUIT")

;SearchHelp3("SendMessage")
;SearchHelp3("CreateWindowEx")
;SearchHelp3("DrawTextEx")
;SearchHelp3("DragQueryFile")
;SearchHelp3("AttachConsole")
;SearchHelp3("WM_QUIT")
;SearchHelp3("DT_CENTER")

;SearchHelp3Online("CreateWindowEx")

;RunProgram("ms-xhelp:///?method=keywords&format=xml&query=MessageBoxEx&product=vs&productversion=100&locale=en-us&category=topic")
;End


;ONLINE ONLY
;
; Can’t find requested content on your computer
;
; -search -> content moved
;
;DispCallFunc_ (pvInstance, oVft, cc, vtReturn, cActuals, prgvt, prgpvarg, pvargResult)
;DispGetIDsOfNames_ (ptinfo, rgszNames, cNames, rgdispid)
;DispGetParam_ (pdispparams, position, vtTarg, pvarResult, puArgErr)
;DispInvoke_ (_this, ptinfo, dispidMember, wFlags, pparams, pvarResult, pexcepinfo, puArgErr)


; 1600 checked

Word$ = GetEnvironmentVariable("PB_TOOL_Word")
If Word$=""
    RunMSXhelp("ms-xhelp:///?method=page&id=-1&format=html&devlang=c++&targetos=windows&product=vs&embedded=true&productversion=100&locale=en-us")
Else
    If LCase(ProgramParameter(0)) = "-search"
        If Right(Word$,1)="_"
            Word$ = Left(Word$,Len(Word$)-1)
        EndIf
        SearchHelp3(Word$)
    ElseIf LCase(ProgramParameter(0)) = "-keyword"
        If Right(Word$,1)="_"
            Word$ = Left(Word$,Len(Word$)-1)
        EndIf
        SearchHelp3Keyword(Word$)
    ElseIf Right(Word$,1)="_"
        ;If Right(Word$,1)="_"
        ;    Word$ = Left(Word$,Len(Word$)-1)
        ;EndIf
        Word$ = Left(Word$,Len(Word$)-1)
        Restore functions
        Repeat
            Read.s s.s
            If Asc(s)='@'
                category.s = Mid(s,2)
                Continue
            EndIf
            If LCase(s) = LCase(Word$)
                Word$ = category + s : Break
            EndIf
        Until s = ""
        If s = "" And category <> "END"
            ;MessageRequester("INFO","no END found!")
        EndIf
        If s=""
            OpenHelp3(Word$)
            ;SearchHelp3(Word$)
        Else
            OpenHelp3(Word$)
        EndIf
    Else
        SearchHelp3(Word$)
        ;OpenHelp3(Word$)
    EndIf

    ;Delay(1000)    
    ;If GetEnvironmentVariable("PB_TOOL_MainWindow")
    ;    SetForegroundWindowInternal( Val(GetEnvironmentVariable("PB_TOOL_MainWindow")) )
    ;EndIf
EndIf

DataSection
    functions:
        Data.s "@winuser/"   ; user32.lib
        Data.s "CreateWindow","CreateWindowA","CreateWindowW"
        IncludeFile "user32.def.pbi"

;         Data.s "messagebox", "drawtext", "loadcursor", "iswindow"
;         Data.s "setforegroundwindow","getforegroundwindow"
;         Data.s "getclassname","getclasslong","setclasslong","getclassword"
;         Data.s "setclassword","getclassinfo"
;         Data.s "findwindow","findwindowex","showwindow"
;         Data.s "setwindowtext","getwindowtext", "animatewindow","appendmenu"
;         Data.s "arrangeiconicwindows","changeclipboardchain","checkmenuitem","checkmenuradioitem"
;         Data.s "childwindowfrompoint", "childwindowfrompointex","closewindow","copyimage","copyrect"
;         Data.s "createcaret","createmenu","createpopupmenu","deferwindowpos","deletemenu","destroymenu"
;         Data.s "dlgdirlist","dlgdirlistcombobox","dragdetect","drawanimatedrects","drawcaption","drawedge"
;         Data.s "drawfocusrect","drawframecontrol","drawicon","drawiconex","drawmenubar","drawstate"
;         Data.s "drawtext","drawtextex","enablemenuitem","enablewindow","endpaint","enumprops"
;         Data.s "equalrect","excludeupdatergn","fillrect","flashwindow","flashwindowex","framerect"
;         Data.s "getactivewindow","getancestor","getcapture","getcaretpos","getclientrect"
;         Data.s "getclipboarddata","getclipboardowner","getclipboardviewer","getcomboboxinfo"
;         Data.s "getcursor","getdc","getdcex","getdesktopwindow","getlastactivepopup","getlistboxinfo"
;         Data.s "getmenu","getmenubarinfo","getmenucontexthelpid","getmenuinfo","getmenuitemcount"
;         Data.s "getmenuitemid","getmenuiteminfo","getmenustate","getmenustring"
;         Data.s "getnextdlggroupitem","getnextdlgtabitem","getopenclipboardwindow"
        

        Data.s "@winbase/"   ; kernel32.lib
        IncludeFile "kernel32.def.pbi"

;         Data.s "sleep", "getlasterror","setlasterror","formatmessage", "closehandle","cancelio"
;         Data.s "createdirectory","createfile","createprocessasuser","createthread","deletefile"
;         Data.s "deviceiocontrol","findclose","findfirstfile","findfirstfileex","freeresource"
;         Data.s "getcurrentdirectory","getenvironmentvariable","getfileattributes","getfileattributesex"
;         Data.s "getfilesize","getfiletime","getoverlappedresult"
        

        Data.s "@wingdi/"    ; gdi32.lib
        IncludeFile "gdi32.def.pbi"
;         Data.s "abortdoc","abortpath","anglearc","animatepalette","arc","arcto"
;         Data.s "beginpath", "chord", "closefigure","combinergn"
;         Data.s "createbitmap","createbitmapindirect","createbrushindirect"
;         Data.s "createcompatiblebitmap","createcompatibledc","createdc","createdibpatternbrush"
;         Data.s "creatediscardablebitmap", "createellipticrgn","createellipticrgnindirect"
;         Data.s "createfont","createfontindirect","createhalftonepalette","createhatchbrush"
;         Data.s "createic","createpalette","createpatternbrush","createpen","createpenindirect"
;         Data.s "createpolygonrgn","createpolypolygonrgn","createrectrgn","createrectrgnindirect"
;         Data.s "createroundrectrgn","createsolidbrush","deletedc","deleteobject"
;         Data.s "devicecapabilities","dptolp","dptotp"
;         Data.s "drawescape","ellipse","enddoc","endpage","endpath","enumobjects","equalrgn"
;         Data.s "escape","excludecliprect","extfloodfill","extescape","exttextout","fillpath","fillrgn"
;         Data.s "flattenpath","floodfill","framergn","getarcdirection", "getbitmapbits"
;         Data.s "getbkcolor","getbkmode","getboundsrect","getcharabcwidths","getcharabcwidthsfloat"
;         Data.s "getcharacterplacement","getcharwidth","getcharwidth32","getcharwidthfloat"
;         Data.s "getclipbox","getcoloradjustment","getdevicecaps","getenhmetafile","getfontdata"
;         Data.s "getfontlanguageinfo","getglyphoutline","getgraphicsmode","getkerningpairs"
;         Data.s "getmapmode","getmiterlimit","getnearestcolor","getnearestpaletteindex"
;         Data.s "getobject","getobjecttype","getoutlinetextmetrics"
        
        
        Data.s "@shellapi/" ; shell32.lib
        XIncludeFile "shell32.def.pbi"
;        Data.s "dragacceptfiles","extracticon"
        
        Data.s "@winsock2/" ; Ws2_32.lib
        XIncludeFile "WS2_32.def.pbi"
;        Data.s "accept","bind","connect","gethostname"
        

        Data.s "@commctrl/" ; Comctl32.lib
        XIncludeFile "ComCtl32.def.pbi"
;        Data.s "drawinsert"
        
        Data.s "@commdlg/"  ; Comdlg32.lib
        XIncludeFile "ComDlg32.def.pbi"
;        Data.s "findtext"
        
        Data.s "@objbase/"  ; Ole32.lib
        Data.s "cocreateinstance","cocreateinstanceex"
        
        Data.s "@ole2/"     ; Ole32.lib
        Data.s "dodragdrop"

        Data.s "@sspi/"     ; Secur32.lib
        Data.s "encryptmessage"
        
        Data.s "@winspool/" ; Winspool.lib
        Data.s "getjob"


        Data.s "@END"
        Data.s ""
EndDataSection

;#WM_QUIT
;#WM_LBUTTONDOWN
;WNDCLASSEX

; IDE Options = PureBasic 5.20 LTS (Windows - x86)
; CursorPosition = 78
; Folding = --
; EnableXP
; Executable = Open_VS2010_Help.exe
; CPU = 5
; CompileSourceDirectory